﻿Imports ConfigurationUtility
Public Class frmTimerCalibration
    Public NCDComponent1 As NCDEnterprise.NCDController
    Public CancelTestClick As Boolean = False
    Public UsingAPI As Boolean = frmMain.UsingAPI ' flag for if using API mode
    ' Public FormLoading As Boolean = True

    Private Sub frmTimerCalibration_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Debug.Print("Turning Off Calibrators...")
        Dim i As Integer
        NCDComponent1.ReadTimeOut = 1000

        'Turn Off Calibration Mode when Form is Closed
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 135)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(135)
        i = Confirm()


    End Sub        ' define a public variable so that the parents form can assign a value to it
    Private Sub frmTimerCalibration_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        '  If FormLoading = True Then GoTo ExitForm


        If UsingAPI = True Then
            Me.Text = Me.Text + " (API Mode)"
        End If
        Dim LSB As Integer
        Dim MSB As Integer
        Dim SLIDE As Integer

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 133)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(133)
        Dim rData As Byte() = NCDLib.ReadBytesAPI(NCDComponent1, UsingAPI, 2)
        If (Not (rData Is Nothing)) Then
            MSB = rData(1)
            LSB = rData(0)
            'LSB = Confirm()
            'MSB = Confirm()
            SLIDE = (LSB + (MSB * 256)) '/ 2
            If SLIDE < TimeCalSlider.Minimum Then
                TimeCalSlider.Value = TimeCalSlider.Minimum
            Else
                TimeCalSlider.Value = SLIDE
            End If
            GroupBox1.Text = "Calibrate the Timer: 1 Second = " + TimeCalSlider.Value.ToString + " Counts."
        End If

        'ExitForm:

        '      FormLoading = False

    End Sub
    Private Sub ReadCal_Click(sender As System.Object, e As System.EventArgs) Handles ReadCal.Click
        'Form1.ProXR1.ClearBuffer()
        'Form1.PutData(254)        'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(133)        'Get Calibration Value Stored in EEPROM
        'LSB = Form1.GetData
        'MSB = Form1.GetData
        'Slide = (LSB + (MSB * 256)) / 2
        'If Slide < TimeCalSlider.Min Then
        '    TimeCalSlider.Value = TimeCalSlider.Min
        'Else
        '    TimeCalSlider.Value = Slide
        'End If

        Dim LSB As Integer
        Dim MSB As Integer
        Dim SLIDE As Integer

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 133)
        Dim rData As Byte() = NCDLib.ReadBytesAPI(NCDComponent1, UsingAPI, 2)
        If (Not (rData Is Nothing)) Then
            MSB = rData(1)
            LSB = rData(0)
            'LSB = Confirm()
            'MSB = Confirm()
            SLIDE = (LSB + (MSB * 256)) '/ 2
            If SLIDE < TimeCalSlider.Minimum Then
                TimeCalSlider.Value = TimeCalSlider.Minimum
            Else
                TimeCalSlider.Value = SLIDE
            End If
        End If

        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(133)
        'LSB = Confirm()
        'MSB = Confirm()
        'SLIDE = (LSB + (MSB * 256)) '/ 2
        'If SLIDE < TimeCalSlider.Minimum Then
        '    TimeCalSlider.Value = TimeCalSlider.Minimum
        'Else
        '    TimeCalSlider.Value = SLIDE
        'End If

    End Sub
    Private Sub StoreCal_Click(sender As System.Object, e As System.EventArgs) Handles StoreCal.Click
        'temp = TimeCalSlider.Value
        'DAT = temp * 2
        'LSB = (DAT And 255)
        'MSB = (DAT And 65280) / 256
        'Debug.Print(LSB)
        'Debug.Print(MSB)

        'Form1.PutData(254)        'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(132)        'Change Calibration Value Stored in EEPROM
        'Form1.PutData(LSB)        'LSB
        'Form1.PutData(MSB)        'MSB
        'Form1.GetData()

        Dim LSB As Integer
        Dim MSB As Integer
        Dim SLIDE As Integer

        SLIDE = TimeCalSlider.Value '* 2
        LSB = (SLIDE And 255)
        MSB = (SLIDE And 65280) / 256

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 132, LSB, MSB)

        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(132)
        'NCDComponent1.WriteByte(LSB)
        'NCDComponent1.WriteByte(MSB)
        Debug.Print(Confirm.ToString)


        'LSB = Confirm()
        'MSB = Confirm()
        'SLIDE = (LSB + (MSB * 256)) / 2
        'If SLIDE < TimeCalSlider.Minimum Then
        '    TimeCalSlider.Value = TimeCalSlider.Minimum
        'Else
        '    TimeCalSlider.Value = SLIDE
        'End If


    End Sub
    Private Sub TestCal1_Click(sender As System.Object, e As System.EventArgs) Handles TestCal1.Click


        Dim centuryBegin As Date = #1/1/2001#
        Dim currentDate As Date = Date.Now
        Dim elapsedTicks As Long = currentDate.Ticks - centuryBegin.Ticks
        Dim elapsedSpan As New TimeSpan(elapsedTicks)

        Dim HR As Integer
        Dim MN As Integer
        Dim SC As Integer

        'Turn On Calibrator
        'This Command tells the Controller to Signal the Starting and Stopping of a Timer
        'When the Calibrator is ON:
        'The Controller will Send 90 at the beginning of any timer.
        'The Controller will send 91 at the end of any timer.
        'The elapsed time between 90 and 91 is used to help you calibrate the timer
        Debug.Print("Turn On Calibrator")
        'Form1.PutData(254)    'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(134)    'Turn On Calibrator Command
        'Form1.GetData()

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 134)

        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(134)
        Debug.Print(Confirm.ToString)
        Debug.Print("------------------")
        'Determine Duration of Test
        NCDComponent1.Purge()       'Form1.ProXR1.ClearBuffer()
        If RadioButton1.Checked = True Then HR = 0 : MN = 0 : SC = 5 'If TimeTest(0).Value = True Then HR = 0 : MN = 0 : SC = 5
        If RadioButton2.Checked = True Then HR = 0 : MN = 0 : SC = 10 'If TimeTest(1).Value = True Then HR = 0 : MN = 0 : SC = 10
        If RadioButton3.Checked = True Then HR = 0 : MN = 0 : SC = 30 'If TimeTest(2).Value = True Then HR = 0 : MN = 0 : SC = 30
        If RadioButton4.Checked = True Then HR = 0 : MN = 0 : SC = 60 'If TimeTest(3).Value = True Then HR = 0 : MN = 0 : SC = 60
        If RadioButton5.Checked = True Then HR = 0 : MN = 5 : SC = 0 'If TimeTest(4).Value = True Then HR = 0 : MN = 5 : SC = 0
        If RadioButton6.Checked = True Then HR = 0 : MN = 10 : SC = 0 'If TimeTest(5).Value = True Then HR = 0 : MN = 10 : SC = 0
        If RadioButton7.Checked = True Then HR = 0 : MN = 30 : SC = 0 'If TimeTest(6).Value = True Then HR = 0 : MN = 30 : SC = 0
        If RadioButton8.Checked = True Then HR = 0 : MN = 60 : SC = 0 'If TimeTest(7).Value = True Then HR = 0 : MN = 60 : SC = 0
        If RadioButton9.Checked = True Then HR = 5 : MN = 0 : SC = 0 'If TimeTest(8).Value = True Then HR = 5 : MN = 0 : SC = 0
        If RadioButton10.Checked = True Then HR = 10 : MN = 0 : SC = 0 'If TimeTest(9).Value = True Then HR = 10 : MN = 0 : SC = 0
        If RadioButton11.Checked = True Then HR = 24 : MN = 0 : SC = 0 'If TimeTest(10).Value = True Then HR = 24 : MN = 0 : SC = 0
        If RadioButton12.Checked = True Then HR = 48 : MN = 0 : SC = 0 'If TimeTest(11).Value = True Then HR = 48 : MN = 0 : SC = 0
        Debug.Print("Setup Timer")

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 50, HR, MN, SC, 0)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)    'Form1.PutData(254)     'Enter Command Mode
        'NCDComponent1.WriteByte(50)     'Form1.PutData(50)  'Timer/Setup Branch Commands
        'NCDComponent1.WriteByte(50)     'Form1.PutData(50)      'Activate Relay Timer 0 for Duration Timing
        'NCDComponent1.WriteByte(HR)     'Form1.PutData(HR)      'Hours
        'NCDComponent1.WriteByte(MN)     'Form1.PutData(MN)      'Minutes
        'NCDComponent1.WriteByte(SC)     'Form1.PutData(SC)      'Seconds
        'NCDComponent1.WriteByte(0)      'Form1.PutData(0)       'Relay
        MeasureTime()

    End Sub

    Public Sub MeasureTime()
        TextBox1.Text = "Testing in Progress....."
        CancelTest.Visible = True
        Debug.Print("Waiting for Start Time")
        Dim i As Long
        Dim _Start As Integer
        Dim _Stop As Integer
        Dim StartTime As Long 'Integer 'Long
        Dim StopTime As Long 'Integer 'Long
        Dim Duration As Double 'Integer 'Long
        Dim DefaultReadTimeOut As Integer = NCDComponent1.ReadTimeOut

        NCDComponent1.ReadTimeOut = 1
        Do
            Application.DoEvents()
            'If NCDComponent1.SerialPort.BytesToRead > 0 Then
            i = Confirm()
            'End If
        Loop Until i = 90 Or CancelTestClick = True

        Debug.Print(i.ToString)

        If CancelTestClick = True Then GoTo finish

        _Start = i
        StartTime = Date.Now.Ticks
        Debug.Print("Start")
        Do
            Application.DoEvents()
            'If NCDComponent1.SerialPort.BytesToRead > 0 Then
            i = Confirm91()
            'End If
        Loop Until i = 91 Or CancelTestClick = True
        Debug.Print(i.ToString)
        If CancelTestClick = True Then GoTo finish

        _Stop = i
        StopTime = Date.Now.Ticks   'Timer
        Debug.Print("Stop")
        Debug.Print("Start:" + Str$(StartTime))
        Debug.Print("Stop:" + Str$(StopTime))
        If _Start = 90 Then
            If _Stop = 91 Then
                Duration = (StopTime - StartTime) / 10000000
                Debug.Print(Duration)
                Duration = Format(Duration, "0.000")
                Debug.Print(Duration)
                TextBox1.Text = "Duration: " + Duration.ToString
            End If
        End If
        NCDComponent1.ReadTimeOut = DefaultReadTimeOut


finish:
        If CancelTestClick = True Then
            CancelTestClick = False
            TextBox1.Text = "Test Canceled by User."
        End If
        CancelTest.Visible = False

    End Sub

    Private Sub TestCal2_Click(sender As System.Object, e As System.EventArgs) Handles TestCal2.Click

        Dim centuryBegin As Date = #1/1/2001#
        Dim currentDate As Date = Date.Now
        Dim elapsedTicks As Long = currentDate.Ticks - centuryBegin.Ticks
        Dim elapsedSpan As New TimeSpan(elapsedTicks)

        Dim HR As Integer
        Dim MN As Integer
        Dim SC As Integer

        Dim I As Integer
        Dim x As Integer

        'Turn On Calibrator
        'This Command tells the Controller to Signal the Starting and Stopping of a Timer
        'When the Calibrator is ON:
        'The Controller will Send 90 at the beginning of any timer.
        'The Controller will send 91 at the end of any timer.
        'The elapsed time between 90 and 91 is used to help you calibrate the timer
        Debug.Print("Turn On Calibrator")
        'Form1.PutData(254)    'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(134)    'Turn On Calibrator Command
        'Form1.GetData()

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 134)

        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(134)
        Debug.Print(Confirm.ToString)
        Debug.Print("------------------")
        'Determine Duration of Test
        NCDComponent1.Purge()       'Form1.ProXR1.ClearBuffer()
        If RadioButton1.Checked = True Then HR = 0 : MN = 0 : SC = 5 'If TimeTest(0).Value = True Then HR = 0 : MN = 0 : SC = 5
        If RadioButton2.Checked = True Then HR = 0 : MN = 0 : SC = 10 'If TimeTest(1).Value = True Then HR = 0 : MN = 0 : SC = 10
        If RadioButton3.Checked = True Then HR = 0 : MN = 0 : SC = 30 'If TimeTest(2).Value = True Then HR = 0 : MN = 0 : SC = 30
        If RadioButton4.Checked = True Then HR = 0 : MN = 0 : SC = 60 'If TimeTest(3).Value = True Then HR = 0 : MN = 0 : SC = 60
        If RadioButton5.Checked = True Then HR = 0 : MN = 5 : SC = 0 'If TimeTest(4).Value = True Then HR = 0 : MN = 5 : SC = 0
        If RadioButton6.Checked = True Then HR = 0 : MN = 10 : SC = 0 'If TimeTest(5).Value = True Then HR = 0 : MN = 10 : SC = 0
        If RadioButton7.Checked = True Then HR = 0 : MN = 30 : SC = 0 'If TimeTest(6).Value = True Then HR = 0 : MN = 30 : SC = 0
        If RadioButton8.Checked = True Then HR = 0 : MN = 60 : SC = 0 'If TimeTest(7).Value = True Then HR = 0 : MN = 60 : SC = 0
        If RadioButton9.Checked = True Then HR = 5 : MN = 0 : SC = 0 'If TimeTest(8).Value = True Then HR = 5 : MN = 0 : SC = 0
        If RadioButton10.Checked = True Then HR = 10 : MN = 0 : SC = 0 'If TimeTest(9).Value = True Then HR = 10 : MN = 0 : SC = 0
        If RadioButton11.Checked = True Then HR = 24 : MN = 0 : SC = 0 'If TimeTest(10).Value = True Then HR = 24 : MN = 0 : SC = 0
        If RadioButton12.Checked = True Then HR = 48 : MN = 0 : SC = 0 'If TimeTest(11).Value = True Then HR = 48 : MN = 0 : SC = 0
        Debug.Print("Setup Timer")

        For x = 0 To 7
            NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 90 + x, HR, MN, SC, x)
            'NCDComponent1.Purge()
            'NCDComponent1.WriteByte(254)    'Form1.PutData(254)     'Enter Command Mode
            'NCDComponent1.WriteByte(50)     'Form1.PutData(50)  'Timer/Setup Branch Commands
            'NCDComponent1.WriteByte(90 + x)     'Form1.PutData(50)      'Activate Relay Timer 0 for Duration Timing
            'NCDComponent1.WriteByte(HR)     'Form1.PutData(HR)      'Hours
            'NCDComponent1.WriteByte(MN)     'Form1.PutData(MN)      'Minutes
            'NCDComponent1.WriteByte(SC)     'Form1.PutData(SC)      'Seconds
            'NCDComponent1.WriteByte(x)      'Form1.PutData(0)       'Relay
            I = Confirm()
        Next x

        'Activate All 8 Timers
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 131, 255, 0)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)        'Form1.PutData(254) 'Enter Command Mode
        'NCDComponent1.WriteByte(50)         'Form1.PutData(50)  'Timer/Setup Branch Commands
        'NCDComponent1.WriteByte(131)        'Form1.PutData(131) 'Configure Timer Register
        'NCDComponent1.WriteByte(255)        'Form1.PutData(255) 'Lower 8 Bits (First 8 Timers Activated)
        'NCDComponent1.WriteByte(0)          'Form1.PutData(0)   'Upper 8 Bits (Last 8 Timers Not Activated)
        MeasureTime()



        ''Turn On Calibrator
        ''This Command tells the Controller to Signal the Starting and Stopping of a Timer
        ''When the Calibrator is ON:
        ''The Controller will Send 90 at the beginning of any timer.
        ''The Controller will send 91 at the end of any timer.
        'Form1.PutData(254)    'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(134)    'Turn On Calibrator Command
        'Form1.GetData()
        ''Determine Duration of Test
        'If TimeTest(0).Value = True Then HR = 0 : MN = 0 : SC = 5
        'If TimeTest(1).Value = True Then HR = 0 : MN = 0 : SC = 10
        'If TimeTest(2).Value = True Then HR = 0 : MN = 0 : SC = 30
        'If TimeTest(3).Value = True Then HR = 0 : MN = 0 : SC = 60
        'If TimeTest(4).Value = True Then HR = 0 : MN = 5 : SC = 0
        'If TimeTest(5).Value = True Then HR = 0 : MN = 10 : SC = 0
        'If TimeTest(6).Value = True Then HR = 0 : MN = 30 : SC = 0
        'If TimeTest(7).Value = True Then HR = 0 : MN = 60 : SC = 0
        'If TimeTest(8).Value = True Then HR = 5 : MN = 0 : SC = 0
        'If TimeTest(9).Value = True Then HR = 10 : MN = 0 : SC = 0
        'If TimeTest(10).Value = True Then HR = 24 : MN = 0 : SC = 0
        'If TimeTest(11).Value = True Then HR = 48 : MN = 0 : SC = 0
        ''Setup 8 Timers for Selected Duration
        'For x = 0 To 7
        '    Form1.PutData(254)     'Enter Command Mode
        '    Form1.PutData(50)  'Timer/Setup Branch Commands
        '    Form1.PutData(90 + x)  'Activate Relay Timer x for Duration Timing
        '    Form1.PutData(HR)      'Hours
        '    Form1.PutData(MN)      'Minutes
        '    Form1.PutData(SC)      'Seconds
        '    Form1.PutData(x)       'Relay
        '    Form1.GetData()
        'Next x
        ''Activate All 8 Timers
        'Form1.PutData(254) 'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(131) 'Configure Timer Register
        'Form1.PutData(255) 'Lower 8 Bits (First 8 Timers Activated)
        'Form1.PutData(0)   'Upper 8 Bits (Last 8 Timers Not Activated)
        'Dim i As Long
        'Do
        '    DoEvents()
        '    i = Form1.ProXR1.GetData
        'Loop Until i >= 0
        'Start = i
        'STime = Timer
        'Do
        '    DoEvents()
        '    i = Form1.ProXR1.GetData
        'Loop Until i >= 0
        'StopT = i
        'TimeS = Timer
        'If Start = 90 Then
        '    If StopT = 91 Then
        '        Duration = TimeS - STime
        '        Label7.Caption = Str$(Duration)
        '    End If
        'End If
    End Sub

    Private Sub TestCal3_Click(sender As System.Object, e As System.EventArgs) Handles TestCal3.Click
        Dim centuryBegin As Date = #1/1/2001#
        Dim currentDate As Date = Date.Now
        Dim elapsedTicks As Long = currentDate.Ticks - centuryBegin.Ticks
        Dim elapsedSpan As New TimeSpan(elapsedTicks)

        Dim HR As Integer
        Dim MN As Integer
        Dim SC As Integer

        Dim I As Integer
        Dim x As Integer

        'Turn On Calibrator
        'This Command tells the Controller to Signal the Starting and Stopping of a Timer
        'When the Calibrator is ON:
        'The Controller will Send 90 at the beginning of any timer.
        'The Controller will send 91 at the end of any timer.
        'The elapsed time between 90 and 91 is used to help you calibrate the timer
        Debug.Print("Turn On Calibrator")
        'Form1.PutData(254)    'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(134)    'Turn On Calibrator Command
        'Form1.GetData()
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 134)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)
        'NCDComponent1.WriteByte(50)
        'NCDComponent1.WriteByte(134)
        Debug.Print(Confirm.ToString)
        Debug.Print("------------------")
        'Determine Duration of Test
        'NCDComponent1.Purge()       'Form1.ProXR1.ClearBuffer()
        If RadioButton1.Checked = True Then HR = 0 : MN = 0 : SC = 5 'If TimeTest(0).Value = True Then HR = 0 : MN = 0 : SC = 5
        If RadioButton2.Checked = True Then HR = 0 : MN = 0 : SC = 10 'If TimeTest(1).Value = True Then HR = 0 : MN = 0 : SC = 10
        If RadioButton3.Checked = True Then HR = 0 : MN = 0 : SC = 30 'If TimeTest(2).Value = True Then HR = 0 : MN = 0 : SC = 30
        If RadioButton4.Checked = True Then HR = 0 : MN = 0 : SC = 60 'If TimeTest(3).Value = True Then HR = 0 : MN = 0 : SC = 60
        If RadioButton5.Checked = True Then HR = 0 : MN = 5 : SC = 0 'If TimeTest(4).Value = True Then HR = 0 : MN = 5 : SC = 0
        If RadioButton6.Checked = True Then HR = 0 : MN = 10 : SC = 0 'If TimeTest(5).Value = True Then HR = 0 : MN = 10 : SC = 0
        If RadioButton7.Checked = True Then HR = 0 : MN = 30 : SC = 0 'If TimeTest(6).Value = True Then HR = 0 : MN = 30 : SC = 0
        If RadioButton8.Checked = True Then HR = 0 : MN = 60 : SC = 0 'If TimeTest(7).Value = True Then HR = 0 : MN = 60 : SC = 0
        If RadioButton9.Checked = True Then HR = 5 : MN = 0 : SC = 0 'If TimeTest(8).Value = True Then HR = 5 : MN = 0 : SC = 0
        If RadioButton10.Checked = True Then HR = 10 : MN = 0 : SC = 0 'If TimeTest(9).Value = True Then HR = 10 : MN = 0 : SC = 0
        If RadioButton11.Checked = True Then HR = 24 : MN = 0 : SC = 0 'If TimeTest(10).Value = True Then HR = 24 : MN = 0 : SC = 0
        If RadioButton12.Checked = True Then HR = 48 : MN = 0 : SC = 0 'If TimeTest(11).Value = True Then HR = 48 : MN = 0 : SC = 0
        Debug.Print("Setup Timer")

        For x = 0 To 15
            NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 90 + x, HR, MN, SC, x)
            'NCDComponent1.Purge()
            'NCDComponent1.WriteByte(254)    'Form1.PutData(254)     'Enter Command Mode
            'NCDComponent1.WriteByte(50)     'Form1.PutData(50)  'Timer/Setup Branch Commands
            'NCDComponent1.WriteByte(90 + x)     'Form1.PutData(50)      'Activate Relay Timer 0 for Duration Timing
            'NCDComponent1.WriteByte(HR)     'Form1.PutData(HR)      'Hours
            'NCDComponent1.WriteByte(MN)     'Form1.PutData(MN)      'Minutes
            'NCDComponent1.WriteByte(SC)     'Form1.PutData(SC)      'Seconds
            'NCDComponent1.WriteByte(x)      'Form1.PutData(0)       'Relay
            I = Confirm()
        Next x

        'Activate All 8 Timers
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 254, 50, 131, 255, 255)
        'NCDComponent1.Purge()
        'NCDComponent1.WriteByte(254)        'Form1.PutData(254) 'Enter Command Mode
        'NCDComponent1.WriteByte(50)         'Form1.PutData(50)  'Timer/Setup Branch Commands
        'NCDComponent1.WriteByte(131)        'Form1.PutData(131) 'Configure Timer Register
        'NCDComponent1.WriteByte(255)        'Form1.PutData(255) 'Lower 8 Bits (First 8 Timers Activated)
        'NCDComponent1.WriteByte(255)        'Form1.PutData(0)   'Upper 8 Bits (Last 8 Timers Not Activated)
        MeasureTime()




        ''Turn On Calibrator
        ''This Command tells the Controller to Signal the Starting and Stopping of a Timer
        ''When the Calibrator is ON:
        ''The Controller will Send 90 at the beginning of any timer.
        ''The Controller will send 91 at the end of any timer.
        'Form1.PutData(254)    'Enter Command Mode
        'Form1.PutData(134)    'Turn On Calibrator Command
        'Form1.GetData()
        ''Determine Duration of Test
        'If TimeTest(0).Value = True Then HR = 0 : MN = 0 : SC = 5
        'If TimeTest(1).Value = True Then HR = 0 : MN = 0 : SC = 10
        'If TimeTest(2).Value = True Then HR = 0 : MN = 0 : SC = 30
        'If TimeTest(3).Value = True Then HR = 0 : MN = 0 : SC = 60
        'If TimeTest(4).Value = True Then HR = 0 : MN = 5 : SC = 0
        'If TimeTest(5).Value = True Then HR = 0 : MN = 10 : SC = 0
        'If TimeTest(6).Value = True Then HR = 0 : MN = 30 : SC = 0
        'If TimeTest(7).Value = True Then HR = 0 : MN = 60 : SC = 0
        'If TimeTest(8).Value = True Then HR = 5 : MN = 0 : SC = 0
        'If TimeTest(9).Value = True Then HR = 10 : MN = 0 : SC = 0
        'If TimeTest(10).Value = True Then HR = 24 : MN = 0 : SC = 0
        'If TimeTest(11).Value = True Then HR = 48 : MN = 0 : SC = 0
        ''Setup 8 Timers for Selected Duration
        'For x = 0 To 15
        '    Form1.PutData(254)     'Enter Command Mode
        '    Form1.PutData(50)  'Timer/Setup Branch Commands
        '    Form1.PutData(90 + x)  'Activate Relay Timer x for Duration Timing
        '    Form1.PutData(HR)      'Hours
        '    Form1.PutData(MN)      'Minutes
        '    Form1.PutData(SC)      'Seconds
        '    Form1.PutData(x)       'Relay
        '    Form1.GetData()
        'Next x
        ''Activate All 16 Timers
        'Form1.PutData(254) 'Enter Command Mode
        'Form1.PutData(50)  'Timer/Setup Branch Commands
        'Form1.PutData(131) 'Configure Timer Register
        'Form1.PutData(255) 'Lower 8 Bits (First 8 Timers Activated)
        'Form1.PutData(255) 'Lower 8 Bits (Last 8 Timers Activated)
        'Dim i As Long
        'Do
        '    DoEvents()
        '    i = Form1.ProXR1.GetData
        'Loop Until i >= 0
        'Start = i
        'STime = Timer
        'Do
        '    DoEvents()
        '    i = Form1.ProXR1.GetData
        'Loop Until i >= 0
        'StopT = i
        'TimeS = Timer
        'If Start = 90 Then
        '    If StopT = 91 Then
        '        Duration = TimeS - STime
        '        Label7.Caption = Str$(Duration)
        '    End If
        'End If
    End Sub
    Public Function Confirm()
        Confirm = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI) ' NCDComponent1.ReadByte
        ' If Confirm <> 85 Then
        'MsgBox("Communications Error.  Device did not respond as expected.")
        ' End If
        'Application.DoEvents()
    End Function
    Public Function Confirm91()
        Confirm91 = NCDLib.ReadByteAPI(NCDComponent1, False) ' NCDComponent1.ReadByte
        ' If Confirm <> 85 Then
        'MsgBox("Communications Error.  Device did not respond as expected.")
        ' End If
        'Application.DoEvents()
    End Function

    Private Sub TimeCalSlider_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles TimeCalSlider.Scroll
        TextBox3.Text = TimeCalSlider.Value.ToString
        GroupBox1.Text = "Calibrate the Timer: 1 Second = " + TimeCalSlider.Value.ToString + " Counts."
    End Sub
    Private Sub TimeCalSlider_ValueChanged(sender As Object, e As System.EventArgs) Handles TimeCalSlider.ValueChanged
        TextBox3.Text = TimeCalSlider.Value.ToString
        GroupBox1.Text = "Calibrate the Timer: 1 Second = " + TimeCalSlider.Value.ToString + " Counts."
    End Sub

    Private Sub CancelTest_Click(sender As System.Object, e As System.EventArgs) Handles CancelTest.Click
        CancelTestClick = True
    End Sub
End Class